package com.dj.action.sys;

import org.apache.log4j.Logger;
import org.apache.struts2.convention.annotation.Action;
import org.apache.struts2.convention.annotation.Result;
import org.springframework.beans.factory.annotation.Autowired;
import com.dj.action.base.BaseAction;
import com.dj.pageModel.base.Json;
import com.dj.pageModel.sys.Config;
import com.dj.service.sys.ConfigServiceI;
import com.dj.util.base.ExceptionUtil;
import com.opensymphony.xwork2.ModelDriven;

/**
 * 基站ACTION
 * 
 * @author lili
 * 
 */
@Action(value = "config", results = { @Result(name = "config", location = "/general/admin/config.jsp"), @Result(name = "configAdd", location = "/general/admin/configAdd.jsp"), @Result(name = "configEdit", location = "/general/admin/configEdit.jsp") })
public class ConfigAction extends BaseAction implements ModelDriven<Config> {

	private static final long serialVersionUID = 1L;

	private static final Logger logger = Logger.getLogger(ConfigAction.class);

	private ConfigServiceI configService;

	public ConfigServiceI getConfigService() {
		return configService;
	}

	@Autowired
	public void setConfigService(ConfigServiceI configService) {
		this.configService = configService;
	}

	private Config config = new Config();

	public Config getModel() {
		return config;
	}


	public String config() {
		return "config";
	}
	public String configAdd() {
		return "configAdd";
	}
	public String configEdit() {
		return "configEdit";
	}
	/**
	 * 获得基站数据表格
	 */
	public void datagrid() {
		super.writeJson(configService.datagrid(config));
	}

	/**
	 * 删除一个基站
	 */
	public void delete() {
		Json j = new Json();
		try {
			configService.delete(config.getIds());
			j.setSuccess(true);
			j.setMsg("删除成功！");
			j.setObj(config.getId());
		} catch (Exception e) {
			logger.error(ExceptionUtil.getExceptionMessage(e));
			j.setMsg("删除失败！基站已使用!");
		}
		super.writeJson(j);
	}

	

	public void add() {
		Json j = new Json();
		try {
			configService.add(config);
			j.setSuccess(true);
			j.setMsg("添加成功！");
		} catch (Exception e) {
			logger.error(ExceptionUtil.getExceptionMessage(e));
			j.setMsg("添加失败！");
		}
		super.writeJson(j);
	}



	/**
	 * 编辑基站
	 */
	public void edit() {
		Json j = new Json();
		try {
			configService.update(config);
			j.setSuccess(true);
			j.setMsg("编辑成功!");
		} catch (Exception e) {
			logger.error(ExceptionUtil.getExceptionMessage(e));
			j.setMsg("编辑失败！");
		}
		writeJson(j);
	}

}
