package com.dj.action.sys;

import org.apache.log4j.Logger;
import org.apache.struts2.convention.annotation.Action;
import org.apache.struts2.convention.annotation.Result;
import org.springframework.beans.factory.annotation.Autowired;

import com.dj.action.base.BaseAction;
import com.dj.pageModel.base.Json;
import com.dj.pageModel.sys.Area;
import com.dj.pageModel.sys.Forbid;
import com.dj.pageModel.sys.Station;
import com.dj.service.sys.AreaServiceI;
import com.dj.service.sys.ForbidServiceI;
import com.dj.service.sys.StationServiceI;
import com.dj.util.base.ExceptionUtil;
import com.opensymphony.xwork2.ModelDriven;

/**
 * 禁止卡号等
 * 
 * @author lili
 * 
 */
@Action(value = "forbid", results = {
		@Result(name = "forbid", location = "/general/admin/forbid.jsp"),
		@Result(name = "forbidAdd", location = "/general/admin/forbidAdd.jsp"),
		@Result(name = "forbidEdit", location = "/general/admin/forbidEdit.jsp") })
public class ForbidAction extends BaseAction implements ModelDriven<Forbid> {

	private static final long serialVersionUID = 1L;

	private static final Logger logger = Logger.getLogger(ForbidAction.class);

	private ForbidServiceI forbidService;

	public ForbidServiceI getForbidService() {
		return forbidService;
	}

	@Autowired
	public void setForbidService(ForbidServiceI forbidService) {
		this.forbidService = forbidService;
	}

	private Forbid forbid = new Forbid();

	public Forbid getModel() {
		return forbid;
	}

	public String forbid() {
		return "forbid";
	}

	public String forbidAdd() {
		return "forbidAdd";
	}

	public String forbidEdit() {
		return "forbidEdit";
	}

	/**
	 * 获得基站数据表格
	 */
	public void datagrid() {
		super.writeJson(forbidService.datagrid(forbid));
	}

	/**
	 * 删除一个基站
	 */
	public void delete() {
		Json j = new Json();
		try {
			forbidService.delete(forbid.getIds());
			j.setSuccess(true);
			j.setMsg("删除成功！");
			j.setObj(forbid.getId());
		} catch (Exception e) {
			logger.error(ExceptionUtil.getExceptionMessage(e));
			j.setMsg("删除失败！基站已使用!");
		}
		super.writeJson(j);
	}

	public void add() {
		Json j = new Json();
		try {
			forbidService.add(forbid);
			j.setSuccess(true);
			j.setMsg("添加成功！");
		} catch (Exception e) {
			logger.error(ExceptionUtil.getExceptionMessage(e));
			j.setMsg("添加失败！");
		}
		super.writeJson(j);
	}

	/**
	 * 编辑基站
	 */
	public void edit() {

		Json j = new Json();
		try {
			forbidService.update(forbid);
			j.setSuccess(true);
			j.setMsg("编辑成功!");
		} catch (Exception e) {
			logger.error(ExceptionUtil.getExceptionMessage(e));
			j.setMsg("编辑失败！");
		}
		writeJson(j);
	}
	/**
	 * 删除所有
	 */
	public void deleteall()
	{
		Json j = new Json();
		try {
			forbidService.deleteall();
			j.setSuccess(true);
			j.setMsg("删除所有成功!");
		} catch (Exception e) {
			logger.error(ExceptionUtil.getExceptionMessage(e));
			j.setMsg("删除所有失败！");
		}
		writeJson(j);
	}
	
	/**
	 * 停用所有
	 */
	public void disableall()
	{
		Json j = new Json();
		try {
			forbidService.disableall();
			j.setSuccess(true);
			j.setMsg("停用所有成功!");
		} catch (Exception e) {
			logger.error(ExceptionUtil.getExceptionMessage(e));
			j.setMsg("停用所有失败！");
		}
		writeJson(j);
	}
	
	/**
	 * 启用所有
	 */
	public void enableall()
	{
		Json j = new Json();
		try {
			forbidService.enableall();
			j.setSuccess(true);
			j.setMsg("启用所有成功!");
		} catch (Exception e) {
			logger.error(ExceptionUtil.getExceptionMessage(e));
			j.setMsg("启用所有失败！");
		}
		writeJson(j);
	}

}
