package com.dj.service.sys.impl;

import java.util.ArrayList;
import java.util.List;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import com.dj.dao.base.BaseDaoI;
import com.dj.model.sys.Thelpinfo;
import com.dj.model.sys.Vhelpinfow;
import com.dj.pageModel.base.DataGrid;
import com.dj.pageModel.sys.Helpinfo;
import com.dj.pageModel.sys.Helpinfow;
import com.dj.service.base.impl.BaseServiceImpl;
import com.dj.service.sys.HelpinfoServiceI;


@Service("helpinfoService")
public class HelpinfoServiceImpl extends BaseServiceImpl implements HelpinfoServiceI {

	private BaseDaoI<Thelpinfo> helpinfoDao;
	private BaseDaoI<Vhelpinfow> vhelpinfowDao;

	public BaseDaoI<Thelpinfo> getHelpinfoDao() {
		return helpinfoDao;
	}

	@Autowired
	public void setHelpinfoDao(BaseDaoI<Thelpinfo> helpinfoDao) {
		this.helpinfoDao = helpinfoDao;
	}

	public BaseDaoI<Vhelpinfow> getVhelpinfowDao() {
		return vhelpinfowDao;
	}

	@Autowired
	public void setVhelpinfowDao(BaseDaoI<Vhelpinfow> vhelpinfowDao) {
		this.vhelpinfowDao = vhelpinfowDao;
	}


	@Transactional(readOnly = true, propagation = Propagation.SUPPORTS)
	public DataGrid datagrid(Helpinfow helpinfo) {
		DataGrid j = new DataGrid();
		j.setRows(changeModel(find(helpinfo)));
		j.setTotal(total(helpinfo));
		return j;
	}

	private List<Helpinfow> changeModel(List<Vhelpinfow> thelpinfos) {
		List<Helpinfow> helpinfos = new ArrayList<Helpinfow>();
		if (thelpinfos != null && thelpinfos.size() > 0) {
			for (Vhelpinfow tb : thelpinfos) {
				Helpinfow b = new Helpinfow();
				BeanUtils.copyProperties(tb, b);
				helpinfos.add(b);
			}
		}
		return helpinfos;
	}

	private List<Vhelpinfow> find(Helpinfow helpinfo) {
		String hql = " from Vhelpinfow t where 1=1 ";

		List<Object> values = new ArrayList<Object>();
		hql = addWhere(helpinfo, hql, values);

		if (helpinfo.getSort() != null && helpinfo.getOrder() != null) {
			hql += " order by " + helpinfo.getSort() + " " + helpinfo.getOrder();
		}
		return vhelpinfowDao.find(hql, values, helpinfo.getPage(), helpinfo.getRows());
	}

	private Long total(Helpinfow helpinfo) {
		String hql = "select count(*) from Vhelpinfow t where 1=1 ";
		List<Object> values = new ArrayList<Object>();
		hql = addWhere(helpinfo, hql, values);
		return vhelpinfowDao.count(hql, values);
	}

	private String addWhere(Helpinfow helpinfo, String hql, List<Object> values) {
		/*if(helpinfo.getPersoncode() !=null && !"".equals(helpinfo.getPersoncode().trim()))
		{
			hql += " and t.cardcode like ? ";
			values.add("%%" + helpinfo.getPersoncode().trim() + "%%");

		}*/
//		if (helpinfo.getReadtimeStart()  != null) {
//			hql += " and t.jctime>=? ";
//			values.add(helpinfo.getReadtimeStart());
//		}
//		if (helpinfo.getReadtimeEnd()  != null) {
//			hql += " and t.jctime<=? ";
//			values.add(helpinfo.getReadtimeEnd() );
//		}
		//卡号
				if(helpinfo.getZddz() !=null && !"".equals(helpinfo.getZddz().trim()))
				{
					hql += " and t.zddz = ? ";
					values.add(helpinfo.getZddz().trim());

				}
				//人员编号
				if(helpinfo.getPersoncode() !=null )
				{
					hql += " and t.personcode = ? ";
					values.add(helpinfo.getPersoncode());

				}

				if(helpinfo.getPersonname() !=null && !"".equals(helpinfo.getPersonname().trim()))
				{
					hql += " and t.personname = ? ";
					values.add(helpinfo.getPersonname().trim());

				}
				//增加矿区、人员姓名查询
				if (helpinfo.getReadtimeStart()  != null) {
					hql += " and t.readtime>=? ";
					values.add(helpinfo.getReadtimeStart());
				}
				if (helpinfo.getReadtimeEnd()  != null) {
					hql += " and t.readtime<=? ";
					values.add(helpinfo.getReadtimeEnd() );
				}
				if(helpinfo.getFlag()!=null && !"".equals(helpinfo.getFlag()))
				{
					hql += " and t.state = ? ";
					values.add(helpinfo.getFlag());

				}
				if(helpinfo.getState()!=null && !"".equals(helpinfo.getState()))
				{
					hql += " and t.state = ? ";
					values.add(helpinfo.getState());

				}
				return hql;

	}

	public void delete(String ids) {
		if (ids != null) {
			for (String id : ids.split(",")) {
				helpinfoDao.executeHql("update TWarposition set state = '1' where id = " + id);
}
		}
	}

//	public void add(Helpinfo helpinfo) {
//
//		Thelpinfo t = new Thelpinfo();
//		BeanUtils.copyProperties(helpinfo, t);
//		t.setId(UUID.randomUUID().toString());
//		helpinfoDao.save(t);
//	}



	public void update(Helpinfow helpinfo) {
		Thelpinfo t = helpinfoDao.get(Thelpinfo.class, helpinfo.getId());
		if (t != null) {
			t.setCardcode(helpinfo.getZddz());
			t.setSenid(helpinfo.getSenid());
		//	t.setType(helpinfo.getType());
		//	t.setDl(helpinfo.getDl());
		//	t.setRssi(helpinfo.getRssi());
			t.setState(helpinfo.getFlag());
			//t.setReadtime(helpinfo.getReadtime());
		}
	}
	public void editall() {
		// TODO Auto-generated method stub
		helpinfoDao.executeHql("update Thelpinfo set state = '1'");

	}

}
